Attribute VB_Name = "DD3DModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

'DirectX7 Objekte
Public DX7 As New DirectX7
'DirectDraw7 Objekte
Public DD7 As DirectDraw7
Public PrimarySurface As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Public PriSurfPX As DDPIXELFORMAT
'Direct3D7 Objekte
Public D3D7 As Direct3D7
Public Device As Direct3DDevice7
Public Const DeviceGUID As String = "IID_IDirect3DHALDevice"
Public ViewPort As D3DVIEWPORT7
Public Projection3DMatrix As D3DMATRIX
Public View3DMatrix As D3DMATRIX
Public ClearRec(0) As D3DRECT
Public ddpfZBuffer As DDPIXELFORMAT
Public d3dEnumPFS As Direct3DEnumPixelFormats
Public ZBufferDesc As DDSURFACEDESC2
Public ZBuffer As DirectDrawSurface7

Public Const SCREENWIDTH As Integer = 800
Public Const SCREENHEIGHT As Integer = 600

Public Sub InitDirectDraw(ByVal WindowHandle As Long, ByVal bolDebug As Boolean)
    Dim SurfaceDesc As DDSURFACEDESC2
    Dim ddenum As DirectDrawEnum
    'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
    'Der leere String-Parameter bedeutet,
    'dass der aktive Bildschirmtreiber benutzt werden soll
    Set ddenum = DX7.GetDDEnum
    If bolDebug Then
        Set DD7 = DX7.DirectDrawCreate(ddenum.GetGuid(3))
    Else
        Set DD7 = DX7.DirectDrawCreate("")
    End If
    Set ddenum = Nothing
    'Die Anwendung soll im VollbildModus laufen
    DD7.SetCooperativeLevel WindowHandle, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
    'Auflsung und Farbtiefe deklarieren
    DD7.SetDisplayMode SCREENWIDTH, SCREENHEIGHT, 16, 0, DDSDM_DEFAULT
    'Beschreibung des PrimarySurface mit einem BackBuffer
    'Wichtig ist der Flag DDSCAPS_3DDEVICE, damit weiss DirectX
    'das wir einen 3DDevice haben mchten
    With SurfaceDesc
        .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
        .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX Or DDSCAPS_3DDEVICE
        .lBackBufferCount = 1
    End With
    'PrimarySurface initialisieren auf dem alles abgebildet wird
    Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
    'Fr die Beschreibung des Backbuffers bentigen wir nur
    'den ddsCaps-Bereich
    SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
    'BackBuffer initialisieren in dem alles gezeichnet und dann
    'in die PrimarySurface ge'flipt wird
    Set BackBuffer = PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)
    'Pixelformat der PrimarySurface auslesen
    PrimarySurface.GetPixelFormat PriSurfPX
End Sub

Public Sub InitDirect3D()
    Dim i As Integer
    'zunchst erstellen wir ein D3D-Interface
    Set D3D7 = DD7.GetDirect3D
    'erstellt ein 3DDevice vom BackBuffer mittels
    'der GUID
    Set Device = D3D7.CreateDevice(DeviceGUID, BackBuffer)
    'Z-Buffer erstellen
    Set d3dEnumPFS = D3D7.GetEnumZBufferFormats(DeviceGUID)
    For i = 1 To d3dEnumPFS.GetCount
        Call d3dEnumPFS.GetItem(i, ddpfZBuffer)
        If (ddpfZBuffer.lFlags = DDPF_ZBUFFER) And ddpfZBuffer.lZBufferBitDepth = 16 Then Exit For
    Next i
    ZBufferDesc.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    ZBufferDesc.ddsCaps.lCaps = DDSCAPS_ZBUFFER Or DDSCAPS_VIDEOMEMORY
    ZBufferDesc.lWidth = SCREENWIDTH
    ZBufferDesc.lHeight = SCREENHEIGHT
    ZBufferDesc.ddpfPixelFormat = ddpfZBuffer
    Set ZBuffer = DD7.CreateSurface(ZBufferDesc)
    BackBuffer.AddAttachedSurface ZBuffer
    'Viewport einstellen (Kamera)
    With ViewPort
        .lHeight = SCREENHEIGHT
        .lWidth = SCREENWIDTH
        .lX = 0
        .lY = 0
        .maxz = 1#
        .minz = 0#
    End With
    Device.SetViewport ViewPort
    '3DRect fr Clear einstellen
    ClearRec(0).X1 = ViewPort.lX
    ClearRec(0).Y1 = ViewPort.lY
    ClearRec(0).X2 = ViewPort.lWidth
    ClearRec(0).Y2 = ViewPort.lHeight
    'ViewportMatrix einstellen
    With DX7
        .IdentityMatrix View3DMatrix
        .ViewMatrix View3DMatrix, RVector(0, 0, 0), _
            RVector(0, 0, 3000), RVector(0, 1, 0), 0
    End With
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, View3DMatrix
    'neuen Ursprung der ViewportMatrix einstellen
    Device.GetTransform D3DTRANSFORMSTATE_VIEW, View3DMatrix
    TranslateMatrix View3DMatrix, RVector(PLAYER.x * -1, PLAYER.y * -1, PLAYER.z * -1)
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, View3DMatrix
    'RenderPipeline einstellen
    Device.SetRenderState D3DRENDERSTATE_LIGHTING, False
    Device.SetRenderState D3DRENDERSTATE_SPECULARENABLE, False
    Device.SetRenderState D3DRENDERSTATE_ZENABLE, D3DZB_TRUE
    Device.SetRenderState D3DRENDERSTATE_CULLMODE, D3DCULL_CCW
    'ProjektionsMatrix einstellen
    With DX7
        .IdentityMatrix Projection3DMatrix
        .ProjectionMatrix Projection3DMatrix, 1, 3000, (3.141592 / 4)
    End With
    Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, Projection3DMatrix
    'Zielsurface fr das Rendern setzen
    Device.SetRenderTarget BackBuffer
End Sub

Public Sub TerminateDirectX(ByVal WindowHandle As Long)
    'alte Auflsung wiederherstellen
    'und DX-Objekte vernichten
    ClearBuffer 0, BackBuffer
    PrimarySurface.Flip BackBuffer, DDFLIP_WAIT
    DX7.ZeroMatrix Projection3DMatrix
    DX7.ZeroMatrix View3DMatrix
    Set d3dEnumPFS = Nothing
    Set ZBuffer = Nothing
    Set BackBuffer = Nothing
    Set Device = Nothing
    Set D3D7 = Nothing
    DD7.SetCooperativeLevel WindowHandle, DDSCL_NORMAL
    DD7.RestoreDisplayMode
    Set PrimarySurface = Nothing
    Set DD7 = Nothing
    Set DX7 = Nothing
End Sub

Public Sub ClearBuffer(ByVal color As Long, ByRef dds As DirectDrawSurface7)
    Dim DestRect As RECT
    With DestRect
        .Bottom = SCREENHEIGHT
        .Left = 0
        .Right = SCREENWIDTH
        .Top = 0
    End With
    dds.BltColorFill DestRect, color
End Sub

