Attribute VB_Name = "XFileModule"
'Dieser Source stammt von http://www.vb-fun.de und kann frei
'in EIGENEN (auch in EIGENEN kommerziellen) Projekten verwendet
'werden. Er darf NICHT auf anderen Webseiten oder Foren ohne
'Quellenangabe verffentlicht werden (siehe hierzu auch die
'Hinweise unter "Urheber- und Kennzeichenrecht" im Impressum).
'Fr eventuelle Schden wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

Dim objD3DRM As Direct3DRM3
Dim objD3DMB As Direct3DRMMeshBuilder3
Dim objD3DFrame As Direct3DRMFrame3
Dim objD3DMesh As Direct3DRMMesh

Public Type XGroup
    IndexList() As Integer
    VertexList() As D3DVERTEX
    RenderVertexList() As D3DLVERTEX
    Texture As DirectDrawSurface7
    TextureFileName As String
End Type
Public GroupCount As Long
Public Groups() As XGroup

Public Sub XFile_Load(ByVal FileName As String)
    Dim GIndex As Long
    Dim IIndex As Long
    Dim Index As Long
    Dim ArraySize As Long
    Dim IArray() As Long
    Dim VertCount As Long
    Dim FaceCount As Long
    Dim FaceVertCount As Long
    Dim TempVertex As D3DVERTEX
    Dim TempRMVertex As D3DRMVERTEX

    On Error GoTo ErrOut
    
    'Direct3D RM Objekt erstellen
    Set objD3DRM = DX7.Direct3DRMCreate
    'Direct3D RM MeshBuilder erstellen
    Set objD3DMB = objD3DRM.CreateMeshBuilder
    'es wird versucht das XFile ohne Frames zu laden
    On Error Resume Next
    objD3DMB.LoadFromFile App.Path & "\" & FileName, "", D3DRMLOAD_FIRST, Nothing, Nothing
    'schlug dies fehl, wird versucht das XFile mit Frames zu laden
    If Err.Number <> 0 Then
        Err.Clear
        On Error GoTo ErrOut
        Set objD3DMB = objD3DRM.CreateMeshBuilder
        Set objD3DFrame = objD3DRM.CreateFrame(Nothing)
        objD3DFrame.LoadFromFile App.Path & "\" & FileName, "", D3DRMLOAD_FIRST, Nothing, Nothing
        objD3DMB.AddFrame objD3DFrame
    End If
    'die Normalen einstellen
    objD3DMB.GenerateNormals 3.14 / 4, D3DRMGENERATENORMALS_USECREASEANGLE
    'da die Informationen aus dem MeshBuilder nicht so einfach
    'ausgelesen werden knnen, wird ein Mesh-Objekt mit den
    'Informationen erstellt
    Set objD3DMesh = objD3DMB.CreateMesh
    'anzahl der Objekte im XFile feststellen
    GroupCount = objD3DMesh.GetGroupCount
    ReDim Groups(GroupCount - 1)
    'die Informationen der Objekte aus dem XFile werden ausgelesen
    For GIndex = 0 To objD3DMesh.GetGroupCount - 1
        'Grssenangaben ermitteln
        With Groups(GIndex)
            ReDim .IndexList(0)
            ReDim .VertexList(0)
        End With
        objD3DMesh.GetSizes GIndex, VertCount, FaceCount, FaceVertCount, ArraySize
        ReDim IArray(ArraySize)
        'Objekt-Faces auslesen
        objD3DMesh.GetGroupData GIndex, IArray()
        'falls Textur vorhanden, dann DDSurface erstellen
        If Not objD3DMesh.GetGroupTexture(GIndex) Is Nothing Then
            Groups(GIndex).TextureFileName = App.Path & "\" & objD3DMesh.GetGroupTexture(GIndex).GetName
            Load_TEXTUR Groups(GIndex).TextureFileName, Groups(GIndex).Texture
        End If
        'Schleife ber alle Faces des Objektes um die
        'entsprechenden Faces zu ermitteln
        Dim fanIndex As Long
        Dim j As Long
        Dim bGetFaceCount As Boolean
        IIndex = 0
        bGetFaceCount = False
        If FaceVertCount = 0 Then bGetFaceCount = True
        Do While IIndex < ArraySize
            If bGetFaceCount Then
                FaceVertCount = IArray(IIndex)
                IIndex = IIndex + 1
            End If
            fanIndex = IIndex
            For j = 0 To FaceVertCount - 3
                'Startpunkt hinzufgen
                AddVertexIndex GIndex, IArray(fanIndex)
                'und die beiden anderen Punkte
                AddVertexIndex GIndex, IArray(IIndex + j + 1)
                AddVertexIndex GIndex, IArray(IIndex + j + 2)
            Next
            IIndex = IIndex + FaceVertCount
        Loop
        'Schleife ber alle Vertexe des Objektes um die
        'entsprechenden Vertexe zu ermitteln
        For Index = 0 To VertCount - 1
            objD3DMesh.GetVertex GIndex, Index, TempRMVertex
            With TempRMVertex
                TempVertex.x = .position.x
                TempVertex.y = .position.y
                TempVertex.z = .position.z
                TempVertex.nx = .Normal.x
                TempVertex.ny = .Normal.y
                TempVertex.nz = .Normal.z
                TempVertex.tu = .tu
                TempVertex.tv = .tv
            End With
            AddVertex GIndex, TempVertex
        Next
        'Schleife durch die Faces um die RenderListe zu erstellen
        ReDim Groups(GIndex).RenderVertexList(ArraySize - 1)
        For Index = 0 To ArraySize - 1
            With Groups(GIndex)
                .RenderVertexList(Index).x = .VertexList(VertexIndex(GIndex, Index)).x
                .RenderVertexList(Index).y = .VertexList(VertexIndex(GIndex, Index)).y
                .RenderVertexList(Index).z = .VertexList(VertexIndex(GIndex, Index)).z
                .RenderVertexList(Index).tu = .VertexList(VertexIndex(GIndex, Index)).tu
                .RenderVertexList(Index).tv = .VertexList(VertexIndex(GIndex, Index)).tv
                .RenderVertexList(Index).color = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
                .RenderVertexList(Index).specular = DX7.CreateColorRGBA(1#, 1#, 1#, 1#)
            End With
        Next
    Next

    Set objD3DRM = Nothing
    Set objD3DMB = Nothing
    Set objD3DFrame = Nothing
    Set objD3DMesh = Nothing

    Exit Sub
ErrOut:
    MsgBox "XFile konnte nicht geladen werden"
End Sub

Private Sub AddVertex(groupid As Long, Vertex As D3DVERTEX)
    With Groups(groupid)
        LSet .VertexList(UBound(.VertexList)) = Vertex
        ReDim Preserve .VertexList(UBound(.VertexList) + 1)
    End With
End Sub

Private Function VertexIndex(groupid As Long, Index As Long) As Long
    With Groups(groupid)
        VertexIndex = .IndexList(Index)
    End With
End Function

Private Sub AddVertexIndex(groupid As Long, VertexIndex As Long)
    With Groups(groupid)
        .IndexList(UBound(.IndexList)) = VertexIndex
        ReDim Preserve .IndexList(UBound(.IndexList) + 1)
    End With
End Sub

